
#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    if {![info exists ClassList]} {variable ClassList [list "DataAnalysis" "DataAcquisition"]}
    variable LevelList {ZERO TEST DEBUG INFORMATION WARNING ERROR ALARM FAULT FAILURE CATASTROPHE}
    
    variable Class [lindex $ClassList 0]
    variable Level "INFORMATION"
    variable Source [second $MyInfo]

    set Message ""

    proc InsertLog {s} {
        variable LogText
        variable LogCount
        variable LogFlag
        variable ShowLogFlag
        variable JS

        if {$LogFlag == 1 && $ShowLogFlag == 1} {

            incr LogCount
            if {$LogCount == 1000} {EmptyLog}

            set LogText "$s\n[set LogText]"
        } else {
            if {$JS == ""} {append JS "alert(\""}
            append JS "[string map {\" \\" \n \\n} $s]\\n"
        }
        return ""
    }

    proc EmptyLog {} {
        variable LogText
        variable LogCount

        set LogText ""
        set LogCount 0
    }

    proc PrintLog {} {
        variable LogText
        variable Source

        set rc [catch {::namespace inscope ::urn:MessageLoggerServer do_DefineMessage MessageLogger INFORMATION $Source "$LogText"} m]
    }

   proc show_variables {} {
        variable LogFlag
        variable ShowLogFlag

         InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
   }

     
   proc DefineMessage {Message} {
       global errorCode errorInfo
       global MIDAS_MessageLoggerCode
       variable Class
       variable Level
       variable Source

        set rc [catch {::namespace inscope ::urn:MessageLoggerServer do_DefineMessage $Class $Level $Source "$Message"} m]

        if {$rc != 0} {
            InsertLog "DefineMessage returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
            if {$MIDAS_MessageLoggerCode == 0} then {
                InsertLog "Message defined"
            } else {
                set rc [catch {interp eval "" ::namespace inscope ::urn:MessageLoggerServer do_GetLastError} m]
                InsertLog "Message not defined: error [second $m]; [third $m]"
            }
        }
   }


     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag
       variable JS

       variable Class
       variable Level
       variable Message

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   CLASS    {set Class [lindex $w 1]}
                   LEVEL    {set Level [lindex $w 1]}
                   MESSAGE  {set Message [lindex $cgidata 7]; DefineMessage "$Message"}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"}
               }
           }
       }
    }

}   ;# end of if {$started == 0}



